# The Rox Programming Language

Rox is a programming language aimed at describing hardware. The
compiler translates source code into synthesizable VHDL.

## Building from Source

1. Make sure you have installed the dependencies:

   * `rustc` 1.13 or later
   * `cargo`
   * `gmp` 6.1 or later
   * `mpfr` 3.1 or later
   * `git`

2. Clone the [source] with `git`:

   ```sh
   $ git clone https://github.com/tspiteri/rox.git
   $ cd rox
   ```

[source]: https://github.com/tspiteri/rox

3. Build:

   ```sh
   $ cargo build --release
   ```

4. Install: Once you build, you can copy the generated executable
`rox` to a directory in your path.

## Running

The `rox` executable will read a list of files and output a VHDL for
each component defined in the files. For more help run:


```sh
$ rox --help
```

## License

Rox is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your
option) any later version.

See [LICENSE-GPL](LICENSE-GPL.md) for details.
